<?php
/*
   performs preliminary check
   */

$version_required = '4.2';
$errors = array();

// check PHP version
if (!function_exists('version_compare')) {
   $errors[] = 'You have an old PHP version installed ('.phpversion().'). EasyMoblog requires at least version '.$version_required;
}
elseif (version_compare(phpversion(), $version_required) < 0) {
   $errors[] = 'You have an old PHP version installed ('.phpversion().'). EasyMoblog requires at least versione '.$version_required;
}

$extensions = get_loaded_extensions();

// check if mySQL support is enabled
if (!in_array('mysql', $extensions)) {
   $errors[] = 'You need to activate mySQL support in your PHP configuration';
}

// check if session support is enabled
if (!in_array('session', $extensions)) {
   $errors[] = 'You need to activate session support in your PHP configuration';
}

// check file permissions
$files = array(
   dirname(__FILE__).'/../img/easymoblog',
   dirname(__FILE__).'/../img/posts',
   dirname(__FILE__).'/../img/tmp',
   dirname(__FILE__).'/../img/topics',
   dirname(__FILE__).'/../include'
);

foreach($files as $k => $v) {
   if (!is_writable($v)) {
      $folder = str_replace(dirname(__FILE__).'/../','',$v);
      $errors[] = 'You need to set-up user permissions on the <font style="font-family: Courier New, Courier, mono;"><b>'.$folder.'</b></font> directory (it must be writable): <br />';
   }
}

if (count($errors) == 0) {
   session_start();
   $_SESSION['step'] = 0;
   header ('Location: step_1.php');
   exit();
}
else { // output errors and die
   include('../include/xtemplate.inc.php');
   $tpl = @new XTemplate ('templates/step_0.tpl.htm');   
   foreach($errors as $k => $v) {
      $tpl->assign('ERROR', $v);
      $tpl->parse('main.errors.error');
   }
   $tpl->parse('main.errors');
   $tpl->parse('main');
   $tpl->out('main');
}
?>