<?php
require_once ('../include/config.inc.php');

Header ('Content-type: text/css');


// import CSS from activated modules
if (count($SIDEBAR_MODULES) > 0) {
   for ($mod_cnt = 0; $mod_cnt < count($SIDEBAR_MODULES); $mod_cnt++) {
      if (file_exists(CFG_BASE_PATH.'/modules/'.$SIDEBAR_MODULES[$mod_cnt].'/css/'.$SIDEBAR_MODULES[$mod_cnt].'.css.php')) {
         echo '@import url('.CFG_SITE_URL.'modules/'.$SIDEBAR_MODULES[$mod_cnt].'/css/'.$SIDEBAR_MODULES[$mod_cnt].'.css.php);'."\n";
      }
   }
}
if (count($TOP_MODULES) > 0) {
   for ($mod_cnt = 0; $mod_cnt < count($TOP_MODULES); $mod_cnt++) {
      if (file_exists(CFG_BASE_PATH.'/modules/'.$TOP_MODULES[$mod_cnt].'/css/'.$TOP_MODULES[$mod_cnt].'.css.php')) {
         echo '@import url('.CFG_SITE_URL.'modules/'.$TOP_MODULES[$mod_cnt].'/css/'.$TOP_MODULES[$mod_cnt].'.css.php);'."\n";
      }
   }
}

echo '
   body {
      background: #'.CFG_BODY_BGCOLOR.';
   }

   #header {
      margin-left: auto; margin-right: auto;
      width: '.CFG_PAGE_WIDTH.'px;
      background: #'.CFG_TITLE_BGCOLOR.';
   }

   #header h1, #header a {
      padding: 0; margin: 0;
      font-family: '.CFG_TITLE_FONT_FAMILY.';
      font-size: '.CFG_TITLE_FONT_SIZE.'px;
      font-style: '.CFG_TITLE_FONT_STYLE.';
      color: #'.CFG_TITLE_COLOR.';
      text-decoration: none;
      vertical-align: middle;
   }

   #header h1 a {
      padding-left: 5px;
   }

   #topbar {
      margin-left: auto; margin-right: auto;
      width: '.CFG_PAGE_WIDTH.'px;
      background: #'.CFG_TOPBAR_BGCOLOR.';
   }

   .topbar_module {
      display: inline;
      padding-left: 5px;
   }

   #contents {
      margin-left: auto; margin-right: auto;
      width: '.CFG_PAGE_WIDTH.'px;
      overflow: auto;
      background: #'.CFG_POST_BGCOLOR.';
   }

   #sidebar {
      float: right;
      width: '.CFG_SIDEBAR_WIDTH.'px;
      background: #'.CFG_SIDEBAR_BGCOLOR.';
   }

   .sidebar_module {
      margin: 5px;
      width: '.(CFG_SIDEBAR_WIDTH-10).'px;
      padding-bottom: 5px; padding-top: 5px;
   }

   #intro {
      width: '.(CFG_PAGE_WIDTH-CFG_SIDEBAR_WIDTH).'px;
      float: left;
      background: #'.CFG_INTRO_BGCOLOR.';
   }

   #intro p {
      font-family: '.CFG_INTRO_FONT_FAMILY.';
      font-size: '.CFG_INTRO_FONT_SIZE.'px;
      font-style: '.CFG_INTRO_FONT_STYLE.';
      color: #'.CFG_INTRO_COLOR.';
      padding: 5px;
   }

   #page_title {
      float: left;
      padding: 5px;
   }

   #page_title h2 {
      font-family: '.CFG_PAGE_TITLE_FONT_FAMILY.';
      font-size: '.CFG_PAGE_TITLE_FONT_SIZE.'px;
      font-style: '.CFG_PAGE_TITLE_FONT_STYLE.';
      color: #'.CFG_PAGE_TITLE_COLOR.';
   }

   #page_title p {
      font-family: '.CFG_POST_FONT_FAMILY.';
      font-size: '.CFG_POST_FONT_SIZE.'px;
      font-style: '.CFG_POST_FONT_STYLE.';
      color: #'.CFG_POST_COLOR.';
   }

   #posts {
      float: left;
      width: '.(CFG_PAGE_WIDTH-CFG_SIDEBAR_WIDTH).'px;

   }

   .post {
      margin: 5px;
      padding: 5px;
      border: '.CFG_POST_BORDER_WIDTH.'px '.CFG_POST_BORDER_STYLE.' #'.CFG_POST_BORDER_COLOR.';
   }

   .post p, .post p a, #page_title p {
      font-family: '.CFG_POST_FONT_FAMILY.';
      font-size: '.CFG_POST_FONT_SIZE.'px;
      font-style: '.CFG_POST_FONT_STYLE.';
      color: #'.CFG_POST_COLOR.';
      margin: 0; padding: 0;
   }

   .post p a {
      color: #'.CFG_POST_A_COLOR.';
      text-decoration: '.CFG_POST_A_TEXT_DECORATION.';
   }

   .post p a:hover {
      color: #'.CFG_POST_A_HOVER_COLOR.';
      text-decoration: '.CFG_POST_A_HOVER_TEXT_DECORATION.';
   }

   .post img .post_img {
      margin: 5px;
   }

   p.post_header img {
      float: right;
   }

   p.post_header, p.post_header a {
      font-family: '.CFG_POST_HEADER_FONT_FAMILY.';
      font-size: '.CFG_POST_HEADER_FONT_SIZE.'px;
      font-style: '.CFG_POST_HEADER_FONT_STYLE.';
      color: #'.CFG_POST_HEADER_COLOR.';
      text-decoration: '.CFG_POST_A_TEXT_DECORATION.';
      margin: 0; padding: 0;
   }

   p.post_header a:hover {
      color: #'.CFG_POST_A_HOVER_COLOR.';
      text-decoration: '.CFG_POST_A_HOVER_TEXT_DECORATION.';
   }

   .post h3, .post h3 a {
      margin: 0; padding: 0; padding-bottom: 5px;
      font-family: '.CFG_POST_TITLE_FONT_FAMILY.';
      font-size: '.CFG_POST_TITLE_FONT_SIZE.'px;
      font-style: '.CFG_POST_TITLE_FONT_STYLE.';
      color: #'.CFG_POST_TITLE_COLOR.';
      text-decoration: none;
   }

   .post h4, #comments h1, .comment h1 {
      margin: 15px 5px 5px 5px;
      border-top: '.CFG_COMMENTS_SEPARATOR_WIDTH.'px '.CFG_COMMENTS_SEPARATOR_STYLE.' #'.CFG_COMMENTS_SEPARATOR_COLOR.';
      font-family: '.CFG_COMMENTS_TITLE_FONT_FAMILY.';
      font-size: '.CFG_COMMENTS_TITLE_FONT_SIZE.'px;
      font-style: '.CFG_COMMENTS_TITLE_FONT_STYLE.';
      color: #'.CFG_COMMENTS_TITLE_COLOR.';
   }

   .post_footer {
      margin-top: 15px;
   }

   .post_footer, .post_footer a {
      font-family: '.CFG_POST_FOOTER_FONT_FAMILY.';
      font-size: '.CFG_POST_FOOTER_FONT_SIZE.'px;
      font-style: '.CFG_POST_FOOTER_FONT_STYLE.';
      color: #'.CFG_POST_FOOTER_COLOR.';
   }

   .post_footer a {
      color: #'.CFG_POST_FOOTER_A_COLOR.';
      text-decoration: '.CFG_POST_FOOTER_A_TEXT_DECORATION.';
   }

   .post_footer a:hover {
      color: #'.CFG_POST_FOOTER_A_HOVER_COLOR.';
      text-decoration: '.CFG_POST_FOOTER_A_HOVER_TEXT_DECORATION.';
   }

   #comments {
      background: #'.CFG_POST_BGCOLOR.';
   }

   .comment {
      background: #'.CFG_POST_BGCOLOR.';
      margin: 5px;
      padding: 5px;
      border-bottom: '.CFG_COMMENTS_SEPARATOR_WIDTH.'px '.CFG_COMMENTS_SEPARATOR_STYLE.' #'.CFG_COMMENTS_SEPARATOR_COLOR.';
   }

   .comment p.comment_header {
      font-family: '.CFG_COMMENTS_HEADER_FONT_FAMILY.';
      font-size: '.CFG_COMMENTS_HEADER_FONT_SIZE.'px;
      font-style: '.CFG_COMMENTS_HEADER_FONT_STYLE.';
      color: #'.CFG_COMMENTS_HEADER_COLOR.';
   }

   .comment p {
      font-family: '.CFG_COMMENTS_FONT_FAMILY.';
      font-size: '.CFG_COMMENTS_FONT_SIZE.'px;
      font-style: '.CFG_COMMENTS_FONT_STYLE.';
      color: #'.CFG_COMMENTS_COLOR.';
   }

   .comment p a {
      color: #'.CFG_COMMENTS_A_COLOR.';
      text-decoration: '.CFG_COMMENTS_A_TEXT_DECORATION.';
   }

   .comment p a:hover {
      color: #'.CFG_COMMENTS_A_HOVER_COLOR.';
      text-decoration: '.CFG_COMMENTS_A_HOVER_TEXT_DECORATION.';
   }

   #footer {
      margin-left: auto; margin-right: auto;
      width: '.CFG_PAGE_WIDTH.'px;
      height: 30px;
      background: #'.CFG_FOOTER_BGCOLOR.';
   }

   #footer p {
      margin: 0;
      padding: 5px;
      font-family: '.CFG_FOOTER_FONT_FAMILY.';
      font-size: '.CFG_FOOTER_FONT_SIZE.'px;
      font-style: '.CFG_FOOTER_FONT_STYLE.';
      color: #'.CFG_FOOTER_COLOR.';
   }

   #footer #easymoblogo {
      float: right;
      margin: 0; padding: 0;
      display: inline;
   }

   input.comment_form, textarea.comment_form {
      width: 99%;
      margin-bottom: 10px;
   }

   textarea.comment_form {
      height: 150px;
   }

';

mysql_close();
?>
