-- move anonymous user to a var (actual move done in post script)
INSERT INTO vars (name, value, description, type, category) VALUES ('anon_user_nick', 'Anonymous Hero', 'The nickname which will be used for the default anonymous user.', 'text', 'General');
INSERT INTO vars (name, value, description, type, category) VALUES ('anon_user_group', 'Anonymous', 'The group which the standard anonymous user is a part of (most likely, this will be "Anonymous").', 'text', 'General');

-- change category for some vars
UPDATE vars SET category = 'Stories' WHERE name = 'queue_edit_max_time' OR name = 'spam_votes_percentage' OR name = 'spam_votes_threshold';
UPDATE vars SET category = 'Comments,Post Throttle' where name = 'rate_limit_minutes';
UPDATE vars SET category = CONCAT(category, ',Archive') WHERE name = 'poll_archive_age' OR name = 'archive_ratings' OR name = 'archive_moderations' OR name = 'comment_archive_age' OR name = 'story_archive_age';

-- change page title for vars to Site Controls
UPDATE admin_tools SET dispname = 'Site Controls' WHERE tool = 'vars';

-- make it so that rdf_channels.submitted is never NULL
UPDATE rdf_channels SET submitted = 0 WHERE submitted IS NULL;

-- some new vars and blocks
INSERT INTO blocks VALUES ('editqueuespam_bg','#f9e5de','1','Background colour for stories in the edit queue that the user has voted as being "spam"','display','default','en');
INSERT INTO blocks (bid,block,category,theme,language,description) VALUES ("story_vote_form", "<FORM NAME=\"storymoderate\" ACTION=\"%%rootdir%%/\" METHOD=\"POST\">\n\t<INPUT TYPE=\"hidden\" NAME=\"op\" VALUE=\"displaystory\">\n\t<INPUT TYPE=\"hidden\" NAME=\"sid\" VALUE=\"%%sid%%\">\n\t<INPUT TYPE=\"hidden\" NAME=\"mode\" VALUE=\"moderate\">\n\t%%formkey%%\n\t<B>Your vote:</B> <SELECT NAME=\"vote\" SIZE=1>\n\t\t<OPTION VALUE=\"1\">Post it to the Front page! (+1)\n\t\t<OPTION VALUE=\"2\">Post it to Section page Only (+1)\n\t\t<OPTION VALUE=\"0\" SELECTED>Abstain. (0)\n\t\t<OPTION VALUE=\"-1\">Dump it! (-1)\n\t</SELECT>\n\t<INPUT TYPE=\"submit\" NAME=\"save\" VALUE=\"Vote\">\n</FORM>", "content", "default", "en", "special keys: |formkey| is replaced with the appropriate hidden input for validation; |sid| is replaced with the story's sid.");

-- add in some missing vars and blocks
INSERT INTO vars VALUES("blocked_domains", "example.com,\nnospam.com", "A comma-separated list of email domains that may not be used for account creation.", "tarea", "Security");
INSERT INTO blocks VALUES("trusted_info_message", "You are a trusted user.  For more information on the extra rights and responsibilities of trusted users, please see \"<A href=\"%%rootdir%%/special/trusted\">Trusted User Guidelines</A>\".", "1", "This message is shown on the user's own user info page if the user is trusted", "site_html", "default", "en");
INSERT INTO blocks VALUES("untrusted_post_message", "You are an untrusted user. Your comment has been posted, but it must be reviewed by a trusted user before it will become visible. For more information, please see \"<A HREF=\"%%rootdir%%/special/untrusted\">Why am I untrusted?</A>\"", "1", "This message is shown when an untrusted user posts a comment.", "site_html", "default", "en");
INSERT INTO blocks VALUES("subscribe_denied_message", "Sorry, but you can't subscribe to %%sitename%% at this time.", "1", "A message for users when they don't have the allow_subscription perm", "site_html", "default", "en");
INSERT INTO blocks VALUES("subscribe_intro_text", "This is where you should put some introductory information about your subscription offerings.  Edit the block \"subscribe_intro_text\" with the text you want here.", "1", "The text describing what extras subscribers get", "site_html", "default", "en");
INSERT INTO blocks VALUES("sub_email_success", "Your subscription has just been updated.  You have added %%MONTHS%% months to your %%TYPE%% subscription.", "1", "Email sent to the user when the subscription has been updated by Scoop", "email", "default", "en");
INSERT INTO blocks VALUES("ad_submit_help", "", "1", "General instructions for ad submission.  Shown below the preview button on submitad step 3.", "advertising", "default", "en");
INSERT INTO blocks VALUES("mark_Subscribers", "(!)", "1", "A token that marks subscribed members on their comments if they are in the group Subscribers", "site_html", "default", "en");
INSERT INTO blocks VALUES("new_story_marker", "=>", "1", "A marker like new_comment_marker only for stories", "site_html", "default", "en");
INSERT INTO blocks VALUES("comment_word", "comment", "1", "If you use some word other than 'comment' to describe comments, put that word here.  Singular; for the plural suffix, see comment_plural", "site_html", "default", "en");
INSERT INTO blocks VALUES("comment_plural", "s", "1", "The plural suffix for comment_word, if there are more than one comments", "site_html", "default", "en");
INSERT INTO blocks VALUES("comment_num_format_start", "", "1", "A starting HTML format tag, used to format the number of total comments in a story", "display", "default", "en");
INSERT INTO blocks VALUES("comment_num_format_end", "", "1", "An ending HTML format tag to close comments_num_format_start", "display", "default", "en");
INSERT INTO blocks VALUES("new_comment_format_start", "<B>", "1", "A starting HTML format tag, used to format the number of unread comments in a story", "display", "default", "en");
INSERT INTO blocks VALUES("new_comment_format_end", "</B>", "1", "An ending HTML format tag to close new_comment_format_start", "display", "default", "en");
INSERT INTO blocks VALUES("poll_img_width", "300", "", "How wide, in pixels, a poll result bar with 100% of the votes is. Put another way, the maximum length of a poll's result bars.", "display", "default", "en");

INSERT INTO special VALUES("trusted", "Trusted User Guidelines", "An explanation of what privileges trusted users get, and what responsibilities they have", "<P>This site uses a system called \"Mojo\" to try to keep the comments as high-signal as possible. All users can rate all comments, except their own, between 1 and 5. When your comments are rated by others, those ratings are combined into a weighted average (newer comments count more than older ones) called your \"Mojo\". This, roughly, represents the rating we could expect your next comment to receive based on your past comments.</P>\n\n<P>Users who have a mojo greater than a certain minimum, and who have posted a sufficient number of comments, such as yourself, for example, are considered \"trusted\" users, and have the added capability to rate comments below the normal minimum rating, and also to see comments rated below the minimum (they are hidden from normal users).</P>\n\n<P>This is a great responsibility for you. It means you've earned the right to peer-review content from untrusted users, and determine if it is spam. We rely on you to rate as much as you can, and to keep the comments as high-signal as we've all come to expect.</P>\n\n<P>Please use your \"zero\" rating with care! It is *only* for use on comments that are wholly content-free. If you think the poster is clueless, or an idiot, or you just don't agree with them, that is *not* grounds for a zero rating. Zero is for comments that are offensive, script-generated, or otherwise content-free and intended solely to annoy and/or abuse other readers.</P>\n\n<P><B>Please do not rate duplicate comments 0! As virtually all duplicate comments are accidental, this unfairly impacts the poster's mojo. A \"1\" rating and an email to %%local_email%% notifying us of the duplicate (please include direct link to the comment) is the appropriate response.</B></P>\n\n<P>You also have a duty to read comments posted by untrusted users (you are the only ones who can!) and rate them up if they deserve to be viewable. We hate to see users become untrusted, and want them to rejoin the community, and rating them up when they post good comments is the only way for that to happen.</P>\n\n<P>It is a cruel irony that those who are trusted, in any context, usually have more work with no particular reward for that work, and that is the case here as well. You still post with no initial rating, like a normal user, and your ratings do not carry any extra weight or power. The big reward for being trusted is that you get to see the bottom-of-the-barrel dreck. But basically, someone has to do this, and you have shown the rest of the %%sitename%% readers that you have the responsibility and perception to be trusted with this task. Hopefully there are enough of you that no one person will have to expend any unreasonable efforts.</P>\n\n<P>Thank you for contributing to %%sitename%%, and for taking on the mantle of responsibility for keeping the site as high-quality as you've helped make it. I, and all the other readers, salute you.");
INSERT INTO special VALUES("untrusted", "Why am I untrusted?", "An explanation of why somebody is untrusted, and what they can do about it", "<P>This site uses a system called \"Mojo\" to try to keep the comments as high-signal as possible. All users can rate all comments, except their own, between 1 and 5. When your comments are rated by others, those ratings are combined into a weighted average -- newer comments count more than older ones -- called your \"Mojo\". This, roughly, represents the rating we could expect your next comment to receive based on your past comments.</P>\n\n<P>Users who have a mojo greater than a certain minimum and who have posted a sufficient number of comments are considered \"trusted\" users, and have the added capability to rate comments below the normal minimum rating. If enough of a user's comments are rated below 1, that user becomes \"untrusted\", which means that respected members of the community have repeatedly indicated that your input is offensive, content-free, or merely intended to annoy others.</P>\n\n<P>If you are untrusted, then your comments are posted with an initial rating equal to your mojo. Since this is below the normal rating minimum, these comments are not visible to any but trusted users. They may, if they choose, rate your comments above the minimum, and make them visible to others. You may earn back the trust of the community simply by posting worthwhile comments, and not spamming.</P>\n\n<P>Please do not see this as a condemnation of you as a person. We're sure you're very nice once we get to know you. This merely means that perhaps you've posted some rather ill-considered comments, and the community as a whole has decided that we'd rather have your input peer-reviewed before it goes out to the general public. Next time you post, think carefully about what you're saying and whether it adds to the topic at hand. If not, there are plenty of places on the web that don't filter input at all, and would be glad to hear whatever's on your mind.</P>\n\n<P>If you believe your posting history does not warrant an untrusted rating and you have been the victim of malicious rating, then please contact us at %%local_email%%. Think carefully, and review your previous comments before you do this. If you complain and have in fact been spamming, then I will not be pleased with you. If your untrusted rating is unjustified though, then we will deal with the situation.</P>\n\n<P>Thank you for reading %%sitename%%.</P>");

-- defaults for blocks which will be moved out of vars by script
INSERT INTO blocks VALUES ('norm_font_end','</FONT>',NULL,'the font end tag from norm_font, will be moved to a block soon.','display','default','en');
INSERT INTO blocks VALUES ('box_title_font','<FONT FACE=\"verdana, arial, helvetica, sans-serif\" SIZE=2 COLOR=\"#FFFFFF\"><B>',NULL,'font tag for box titles.  Will be moved to a block soon.','display','default','en');
INSERT INTO blocks VALUES ('title_font_end','</B></FONT>',NULL,'end font tag for story titles.  will be changed to a block soon','display','default','en');
INSERT INTO blocks VALUES ('norm_font_face','verdana, arial, helvetica, sans-serif',NULL,'the font face for normal text. Used in user prefs','display','default','en');
INSERT INTO blocks VALUES ('title_font','<FONT FACE=\"verdana, arial, helvetica, sans-serif\" SIZE=3><B>',NULL,'font tag for story titles.  Will be changed to a block soon.','display','default','en');
INSERT INTO blocks VALUES ('box_title_font_end','</B></FONT>',NULL,'end font tag for box titles.  Will be moved to a block soon','display','default','en');
INSERT INTO blocks VALUES ('norm_font_size','2',NULL,'\'the font size for normal text. Used in user prefs','display','default','en');
INSERT INTO blocks VALUES ('norm_font','<FONT FACE=\"verdana, arial, helvetica, sans-serif\" SIZE=2>',NULL,'The fornt to use for normal text, will be moved to a block soon.','display','default','en');
INSERT INTO blocks VALUES ('poll_img','pollbar.gif',NULL,'Image which is stretched horizontally to form the poll result bars. Value must be the name of a file in the images/ directory.','display','default','en');

-- add a cron to mark old ads inactive
INSERT INTO box (boxid, title, content, description, template) VALUES ('mark_ads_inactive', '', 'my ($rv, $sth) = $S->db_update({\r\n    WHAT => \'ad_info\',\r\n    SET  => \'active = 0\',\r\n    WHERE => \'views_left <= 0 AND perpetual != 1 AND active = 1\'\r\n});\r\n$sth->finish();\r\n', 'Mark ads inactive after they\'ve run out of views.', 'blank_box');
INSERT INTO cron (name, func, run_every, enabled, is_box) VALUES ('mark_ads_inactive', 'mark_ads_inactive', 86400, 0, 1);

-- added documentation to var descriptions to go along with the new SAG
-- Look for FIXME for skipped or postponed descriptions
UPDATE vars SET description="<P>This variable affects the activation of new advertisements.  The possible values are: 1) activate an advertisement automatically when the ad is approved by an admin; and 0) the advertisement is activated by the payment processing system.<BR>\nThe default value is 1.  If you <I>are not</I> getting payments for the ads via Scoop's payment processing system, 1 is an appropriate value.  If you <I>are</I> getting payments for the ads via Scoop's payment processing system, the ads will be activated by the payment processing system once they have been approved and paid for and this variable can be set to 0.<BR>\nThis variable has no effect unless the variable <B>use_ads</B> is set to 1.<BR>\nSetting this variable to 1 when you are using Scoop's payment processing system results in ads paid for via credit card to not actually get paid for, as credit card payments are approved through the credit card company, then sent for admin approval, and only after approval are they actually paid for and activated by the cc_bill_orders box.</P>" WHERE name="activate_upon_approve";
UPDATE vars SET description="<P>This variable is used throughout Scoop, whenever something requires the attention of an administrator.  The only possible values for this variable are a single valid email address or a list of valid email addresses separated by commas.<BR>\nThe default value is an invalid email address, and must be changed.  The email address entered should be the email address of the site administrator or administrators, and should be one that is checked regularly.<BR>\nMany error and security functions depend on this variable holding a valid, actively read email address.  If this variable contains an invalid or unread email address, notices of site errors, posting violations, and situations which require admin intervention will not be dealt with as an email to the addresses in this variable are usually the only notification provided.</P>" WHERE name="admin_alert";
UPDATE vars SET description="<P>This variable affects the judging process for new advertisements.  The possible values are: 0) Only paid ads will be presented for judging and approval, or 1) All ads not yet approved will be presented for judging and approval, regardless of paid status.<BR>\nThe default value is 1.  If you are offering free ads, setting this variable to 1 is required, as no ads will ever be paid.  If you are offering only paid ads, setting this variable to 0 is recommended, so you don't have to sort through a mixture of paid and unpaid ads awaiting approval.  If you are offering a mixture of free and paid ads, you will have to set this variable to 1 in order to find and approve the free ads.<BR>\nThis variable has no effect unless the variable <B>use_ads</B> is set to 1.</P>" WHERE name="ads_judge_unpaid";
UPDATE vars SET description="This variable is not actually used at this time, as most sites which use Scoop's ad server allow regular users to submit advertisements so the feature was never completed." WHERE name="advertiser_group";
UPDATE vars SET description="<P>This variable determines where advertisement file uploads will be stored, if an ad type requiring file uploads is available.  The value must be an absolute local pathname, not ending in a slash.<BR>\nThe default value is a (probably) invalid local path.  The value set here should be that of a path for which apache has full write access, and which is available from the internet at the URL specified in the variable <B>ad_server_url</B>.  In both cases, the user id is appended as a subdirectory, and the file is placed in the user's subdirectory.  If the path set in this variable does not exist, or does not allow apache write access, any ads that require file uploads will not work.<BR>\nThis variable has no effect unless the variable <B>use_ads</B> is set to 1.</P>" WHERE name="ad_files_base";
UPDATE vars SET description="<P>This variable determines where advertisement files will be served from.  This does not apply to text ads, only to ads including a separate file, such as an image file.  The value must be an absolute public URL ending in a slash, including any path elements required to bring it to the same level as the local pathname set in <B>ad_files_base</B>.  In both cases, the user id is appended as a subdirectory, and the file is placed in the user's subdirectory.  If this public URL does not correspond to the local path set in <B>ad_files_base</B>, the saved ad files will not be displayed.<BR>\nThis variable has no effect unless the variable <B>use_ads</B> is set to 1.</P>" WHERE name="ad_server_url";
UPDATE vars SET description="<P>This variable determines which section advertisements will be filed in if they allow comments.  The value must be the internal name (not the display name) of an existing section with the section permission \"Post Stories\" set to \"Hide\" for all groups.<BR>\nThe default value is advertisements.  This value is invalid because Scoop does not include an advertisements section by default.  The section name may be any string of letters or numbers, but no spaces.  It should be something that indicates the presence of ads.  Once some ads with discussions available have been posted, this variable <I>should not</I> be changed.<BR>\nThis variable has no effect unless both the variable <B>use_ads</B> and at least one active ad type has the ad property \"Allow Ad Discussions\" turned on.</P>" WHERE name="ad_story_section";
UPDATE vars SET description="<P>This variable determines which topic advertisements will be filed in if they allow comments.  The value must be the internal name (not the display name) of an existing topic.<BR>\nThe default value is ads.  This value is invalid because Scoop does not include an ads topic by default.  The topic name may be any string of letters or numbers, but no spaces.  It may be something that indicates the presence of ads, but a generic topic may also be used, as this topic will also be available to anybody posting a story.  Once some ads with discussions available have been posted, this variable <I>should not</I> be changed.<BR>\nThis variable has no effect unless both the variable <B>use_ads</B> and at least one active ad type has the ad property \"Allow Ad Discussions\" turned on.</P>" WHERE name="ad_story_topic";
UPDATE vars SET description="<P>This variable determines which HTML tags are available to users posting comments or stories, and which elements of those tags are allowed.  The value must follow the format described below.  You should have a reasonable knowledge of HTML before editing this variable.<BR>\nThe default allows a fairly flexible, if limited, subset of HTML in all comments and stories to all user groups.  Tags may be added or removed depending on the culture of the site, and you may specify some tags as allowed only to certain users or only in certain locations.<BR>\nOne HTML tag is listed per line, beginning with the tag itself, followed by a comma-separated list of allowed tag elements and parser commands.  For example:\n<PRE>A, HREF, NAME, -close</PRE>\nallows the A tag to be used with only the elements \"href\" and \"name\", and requires that the tag be closed with a &lt;/A&gt;.  To further specify what is permitted, a perl regular expression may be used alongside a tag element.  For example:\n<PRE>A, HREF=\"^http://\", NAME, -close</PRE>\nallows the A tag to be used with the same two elements as above, but the \"href\" element must contain a value which begins with (the ^ indicates the string following must be at the beginning of the string we're testing against) http://.<BR>\nYou may also specify which user groups are permitted to use a specific HTML tag.  For example:\n<PRE>IMG, src, alt, height, width, -groups=\"Superuser Admins Editors\"</PRE>\nwould allow the use of the IMG tag and the listed tag elements for the three groups listed only.  Any group name may be used here.  The entire list of groups may be inverted, giving all groups <I>except</I> those listed access to the tag with\n<PRE>-group=\"!Anonymous Restricted\"</PRE>\nwhich denies the use of a tag to the Anonymous and Restricted groups but allows it to all others).<BR>\nSimilarly, you may specify where a tag may be used.  For example:\n<PRE>IMG, src, alt, height, width, -context=\"body\"</PRE>\nwould allow the use of the IMG tag to any user group but only in the body (extended copy) of a story.  The list may be inverted in the same way as -group.  Valid contexts are intro (story's intro copy), body (story's extended copy), comment (comment body), and pref (signature and bio fields).<BR>\nWhich tags you permit in which locations depends entirely on you and the culture of your site.  Some sites will do fine with images allowed to all users in all locations; others will need to restrict images or remove them entirely.  Before adding a new tag, consider carefully how it could be used and abused by the members of your site." WHERE name="allowed_html";
UPDATE vars SET description="<P>This variable turns the \"admin notes\" field on or off.  The possible values are: 0) disable admin notes; and 1) enable admin notes.  The default value is 1.<BR>\nAdmin notes are displayed on the edit user form, and are only visible to users with the perm <B>edit_user</B>.  They are useful for a site with multiple admins, so the admins can leave messages for each other regarding a particular account's past abuses, or making a record of changes made to an account.  They can also be useful even when a site has only one admin, so the admin can leave a record of past changes or abuses and not rely on memory.</P>" WHERE name="allow_admin_notes";
UPDATE vars SET description="<P>This variable determines whether or not a user is allowed to renew an existing advertisement.  The possible values are: 0) renewals are not allowed; and 1) renewals are allowed.  The default value is 1.<BR>\nThis variable has no effect unless the advertising system is active.  If ad renewals are permitted, the renewal link is shown on the ad statistics page which only the ad owner can see.</P>" WHERE name="allow_ad_renewal";
UPDATE vars SET description="<P>This variable determines whether or not a new poll can have a pre-set number of votes, before anybody has voted in the poll (also known as ballot stuffing).  The possible values are: 0) do not allow ballot stuffing; and 1) allow ballot stuffing.  The default value is 0.<BR>\n  This variable only applies to users with the perm <B>edit_polls</B>.  \"Stuffed\" ballots do not have any checks made for sanity.  Non-numeric values are changed to 0, but negative values are not filtered and result in some very strange poll results.  If you change the number of votes in the poll, any users who have voted already will not be able to vote again, even if you set the number of votes to zero.</P>" WHERE name="allow_ballot_stuffing";
UPDATE vars SET description="<P>This variable determines whether or not a user may use one of the dynamic comment modes to view comments.  The possible values are: 0) do not allow users to choose either of the dynamic comment modes; and 1) allow users to choose either of the dynamic comment modes.  The default value is 0.<BR>\nBefore dynamic comments can be used, several blocks must be modified to include the necessary javascript and setup information.  See the Scoop Admin Guide for details on how to set up dynamic comments.<BR>\nDynamic comment mode requires javascript to work, and will only work with \"5th generation\" browsers, that is, Netscape 6 or higher, IE 5 or higher, Mozilla, and other browsers with equivalent javascript support.</P>" WHERE name="allow_dynamic_comment_mode";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will allow an admin to fetch external RDF feeds through the RDF Admin Tool.  The possible values are: 0) do not allow RDF fetching through the admin tool; and 1) allow RDF fetching through the admin tool.  The default value is 1.<BR>\nThis variable should be left at 1 unless there is a problem with fetching external RDF feeds through the RDF Admin Tool.  It is intended as a workaround for those situations where Apache cannot be recompiled to correct the issue with RDF fetches.  Please see the Scoop Admin Guide for details.</P>" WHERE name="allow_rdf_fetch";
UPDATE vars SET description="<P>This variable determines whether or not a user may choose between \"sticky\" and \"retroactive\" signatures on their comments.  The possible values are: 0) users may choose only between having a retroactive sig or not having a sig at all; and 1) users may choose between sticky, retroactive, or no sigs.<BR>\nThe default value is 1.<BR>\nDepending on the placement of the comment vs. the signature in the <B>comment</B> and <B>moderation_comment</B> blocks, sticky or no sig may not render correctly.</P>" WHERE name="allow_sig_behavior";
UPDATE vars SET description="<P>This variable determines whether or not any file uploads are permitted.  The possible values are: 0) no file uploads are permitted; and 1) file uploads are permitted.  The default value is 0.<BR>\nPlease see the Scoop Admin Guide for a description of what file upload functions are available, and for an explanation of how to configure them.  The variables which must be configured before this variable is set to 1 are described in the Scoop Admin Guide, and are located in the Uploads category of the Site Controls.</P>" WHERE name="allow_uploads";
UPDATE vars SET description="<P>This variable determines whether or not the user may choose a theme to apply to the site.  The possible values are: 0) users may not choose a theme; and 1) users may choose a theme from a specified list. The default value is 0.<BR>\nIf this variable is set to 1, users may only choose a theme from the list in the variable <B>user_themes</B>, or choose to apply none.  This variable has no effect unless the variable <B>use_themes</B> is set to 1.<BR>\nFor more details on themes, see the Scoop Admin Guide.</P>" WHERE name="allow_user_themes";
UPDATE vars SET description="<P>This variable contains a list of all HTML tags and their possible tag elements, using the same format as the variable <B>allowed_html</B>.  This is used for Scoop's HTML validator and parser for the blocks and special pages.<BR>\nThis variable should generally never be changed.</P>" WHERE name="all_html";
UPDATE vars SET description="<P>This variable sets an anonymously posted comment's initial value.  The possible values are any number between the values set in <B>rating_min</B> and <B>rating_max</B>, inclusive.  The default value is 2.<BR>\nThis variable has no effect unless the variable <B>use_initial_rating</B> is set to 1.<BR>\nThe value is used as an initial comment rating on all comments posted anonymously; a single rating by a user will cause the initial rating to vanish because it is not an actual comment rating.  It is merely used to give unrated comments a rank when comments are sorted by rating.</P>" WHERE name="anonymous_default_points";
UPDATE vars SET description="<P>This variable determines whether or not the voting history of a story is archived when the story is archived.  The possible values are: 0) do not archive the voting history; and 1) archive the voting history.  The default value is 1.<BR>\nThis variable has no effect unless the story archiving system is configured and enabled.  For more details on archiving, see the Scoop Admin Guide.  Since a story's display status (ie, front page or section) is archived with the story, the voting history is not required to determine where it should be displayed but is only available for extra information.</P>" WHERE name="archive_moderations";
UPDATE vars SET category="Stories,Archive" WHERE name="archive_moderations";
UPDATE vars SET description="<P>This variable determines whether or not the individual ratings of a comment are archived when the comment is archived.  The possible values are: 0) do not archive the individual ratings; and 1) archive the individual ratings.  The default value is 1.<BR>\nThis variable has no effect unless the comment archiving system is configured and enabled.  For more details on archiving, see the Scoop Admin Guide.  Since a comment's score and number of ratings are archived with the comment and archived comments cannot be rated, the individual ratings are not required to determine the comment's score, it is only available for extra information.</P>" WHERE name="archive_ratings";
UPDATE vars SET category="Comments,Archive" WHERE name="archive_ratings";
UPDATE vars SET description="<P>This variable extends the \"related links\" box associated with a story by allowing you to define some links Scoop should automatically add every time a particular keyword appears in a story.<BR>\nThis variable affects display only.  The \"related links\" box lists every link in the story in one convenient spot.<BR>\nThe format is a keyword or keyphrase, a comma, and a URL.  One entry per line, no space around the comma, and you must remember to press enter after the last line.</P>" WHERE name="autorelated";
UPDATE vars SET description="<P>This variable determines whether or not the site administrator is notified when a story is posted or dropped using the auto-post algorithm (described in the Scoop Admin Guide).  The possible values are: 0) do not email the admin; and 1) email the admin.  The default value is 1.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.  This variable uses the email addresses present in the variable <B>admin_alert</B> as the recipient.</P>" WHERE name="auto_post_alert";
UPDATE vars SET description="<P>This variable affects the story auto-posting system.  It determines the lowest score at which a story will still be considered for auto-posting.  Any stories with scores below this value will simply be dumped when the auto-post limit is reached.  The possible value is any number between the variables <B>hide_story_threshold</B> and <B>post_story_threshold</B>, inclusive.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.  If this value is set too high, good stories may not be auto-posted when they otherwise should be.<BR>\nPlease read the Scoop Admin Guide for a description of how the auto-post system works.</P>" WHERE name="auto_post_floor";
UPDATE vars SET description="<P>This variable determines the minimum score a story can have for the auto-post algorithm to post it to the site's front page.  The possible values are any number between the variables <B>rating_max</B> and <B>rating_min</B>, including fractional values.  The default value is 4.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.  If the comment rating scale is set to anything other than 1-5, care must be taken when choosing the auto-post thresholds.  See the Scoop Admin Guide for a full description of the auto-posting algorithm.</P>" WHERE name="auto_post_frontpage";
UPDATE vars SET description="<P>This variable determines how long a story must remain in the voting queue before Scoop runs the auto-post algorithm (described in the Scoop Admin Guide) on it.  The possible value is any positive integer number of minutes.  The default value is 2160 (36 hours).<BR>\nThis variable has no effect unless both the variables <B>use_auto_post</B> and <B>auto_post_use_time</B> are set to 1.  If this value is set too low, stories that would otherwise be voted up normally will be subject to auto-posting; if set too high, stories that need auto-posting will languish in the voting queue for far too long.  A suitable value for your site will depend entirely on the amount of traffic you get and how active members are in voting on articles.</P>" WHERE name="auto_post_max_minutes";
UPDATE vars SET description="<P>This variable affects the calculations in the auto-post algorithm (described in the Scoop Admin Guide).  The possible value is any positive integer.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.<BR>\nThis variable is also known as the \"boring story penalty\", since if the number of rated comments in a story is below this number, the number of rated comments used in the auto-post calculations is set equal to this number, while the value of those rated comments is left alone.  This results in a lower score for the story when it is considered for auto-posting.  If the value is too high, it will reduce the number of stories that are auto-posted.</P>" WHERE name="auto_post_min_ratings";
UPDATE vars SET description="<P>This variable determines the minimum score a story can have for the auto-post algorithm to post it to the site's section page.  The possible values are any number between the variables <B>rating_max</B> and <B>rating_min</B>, including fractional values.  The default value is 3.25.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.  This value should not be higher than the value in the variable <B>auto_post_frontpage</B>, as stories with scores higher than that value are posted to the front page without considering this value.  Stories with a score lower than this value are auto-hidden.  See the Scoop Admin Guide for a full description of the auto-posting algorithm.</P>" WHERE name="auto_post_section";
UPDATE vars SET description="<P>This variable determines whether or not the auto-post algorithm is triggered by a time limit or by a total number of votes.  The possible values are: 0) auto-post stories when a certain number of votes have been cast; and 1) auto-post stories when the story has been in the voting queue for more than a certain period of time.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.<BR>\nThe maximum time a story may spend in the queue is set in the variable <B>auto_post_max_minutes</B>.  The maximum number of votes a story may receive before being subject to the auto-post algorithm is set in the variable <B>end_voting_threshold</B>.</P>" WHERE name="auto_post_use_time";
UPDATE vars SET description="<P>This variable determines whether or not comments require new subjects or use the parent comment as a source.  The possible values are: 0) the comment's subject line is empty when a user clicks on the reply link; and 1) the comment's subject line contains \"Re: (previous subject line)\" when a user clicks on the reply link.  The default value is 0.<BR>\nIf the parent comment already has a subject beginning with \"Re:\", Scoop does not add another one.  If the user has changed the subject line, Scoop does not override it with the parent's subject.</P>" WHERE name="carry_comment_titles";
UPDATE vars SET description="<P>This variable determines which character set Scoop sends to a browser.  The possible values are theoretically any valid character set, but there appear to be issues with some non-western character sets (such as big5).  The default value is ISO-8859-1.<BR>\nIf you must use a different character set, be aware that it may cause things to break in unusual ways.  Scoop internationalization is still in the planning stages; check http://scoop.kuro5hin.org/ for any updates.</P>" WHERE name="charset";
UPDATE vars SET description="<P>This variable prevents old stories with still-active discussions from being archived.  The possible values are any positive integer or zero and represent a number of days.  The default is 31.<BR>\nThis variable should be set to a smaller value than <B>story_archive_age</B>.  If zero, stories are archived according to <B>story_archive_age</B> alone; if any positive number, stories that would otherwise be archived are not if they have a comment posted fewer days ago than the value of this variable.</P>" WHERE name="comment_archive_age";
UPDATE vars SET category="Comments,Archive" WHERE name="comment_archive_age";
UPDATE vars SET description="<P>This variable determines whether or not Scoop records the IP address of a poster with each comment.  The possible values are: 0) do not log poster IP address; and 1) log poster IP address.  The default value is 0.<BR>\nHopefully this can help identify problem duplicate accounts.  To view the IP addresses saved, see the variable <B>view_ip_log</B>.</P>" WHERE name="comment_ip_log";
UPDATE vars SET description="<P>This variable sets the default expiry time for Scoop's login cookies.  The possible value is any positive number of seconds, which is added to the current date to create an expiry date for the cookie.  The default value is 2592000 (30 days).<BR>\nThis variable may be overridden by a user preference.</P>" WHERE name="cookie_expire";
UPDATE vars SET description="<P>This variable identifies which poll is currently displayed on the front and section pages.  This variable should not be changed here; to change the front page poll, use the Poll List Admin Tool.</P>" WHERE name="current_poll";
UPDATE vars SET description="<P>This variable names the default box template, for use when a box is not assigned a template on creation.  The possible values are the names of any of the box templates (in the Blocks Admin Tool, in the boxes category).  The default value is box.<BR>\nChanging this value may have unintended effects on the site's display; some boxes may not have had a box template assigned when they were created.</P>" WHERE name="default_box_template";
UPDATE vars SET description="<P>This variable determines whether comments are permitted or not when a new story is created.  The possible values are: 0) comments are permitted; -1) comments are not permitted; and 1) comments are \"read only\".  The default value is 0.<BR>\nThe distinction between \"not permitted\" and \"read only\" is explained in the Scoop Admin Guide.<BR>\nIf you were creating a discussion site, you would want to leave this set to 0; if, however, you were using Scoop to manage articles but did not want comments by regular users, you would then change this value.</P>" WHERE name="default_commentstatus";
UPDATE vars SET description="<P>This variable determines how an anonymous visitor and a new account will see the comments, until they change their comment display preferences.  The possible values are: nested) display the comments with indented replies and all comments shown in full; thread) display the comments with indented replies but all replies as title/author only; minimal) display the comments with indented replies but with all comments as title/author only; and flat) display all comments in the same order as above but without indented replies and all comments shown in full.  The default value is thread.<BR>\nThis variable can be overridden permanently (per user) by a user preference or temporarily by a user changing the comment display mode using the controls between the story and comments.  How this variable is set will determine how new users and search engines will see the comments.</P>" WHERE name="default_comment_display";
UPDATE vars SET description="<P>This variable determines how an anonymous visitor and a new account will see the comments, until they change their comment display preferences.  The possible values are: newest) show the newest top-level comments first, and the oldest comments last (reverse chronological order); and oldest) show the oldest top-level comments first, and the newest comments last (chronological order).  The default value is newest.<BR>\nThis variable can be overridden permanently (per user) by a user preference or temporarily by a user changing the comment display mode using the controls between the story and comments.  This ordering only affects top-level comments; replies are sorted according to which comment they are in reply to.</P>" WHERE name="default_comment_order";
UPDATE vars SET description="<P>This variable determines how an anonymous visitor and a new account will see the comments, until they change their comment display preferences.  The possible values are: highest) sorts comments with higher ratings before comments with lower ratings; lowest) sorts comments with lower ratings before comments with higher ratings; unrate_highest) sorts comments with no ratings at all first, then comments with higher ratings before comments with lower ratings; and dontcare) ignore ratings and sort purely on date.  The default value is dontcare.<BR>\nThis variable can be overridden permanently (per user) by a user preference or temporarily by a user changing the comment display mode using the controls between the story and comments.  This ordering only affects top-level comments; replies are sorted according to which comment they are in reply to.</P>" WHERE name="default_comment_sort";
UPDATE vars SET description="<P>This variable determines how an anonymous visitor and a new account will see the comments, until they change their comment display preferences.  The possible values are: mixed) display both topical and editorial comments in the voting and edit queues, and topical comments only once the story has been posted; topical) display only topical comments; editorial) display only editorial comments; and all) display both topical and editorial comments both in and out of the queues.  The default value is mixed.<BR>\nThis variable can be overridden permanently (per user) by a user preference or temporarily by a user changing the comment display mode using the controls between the story and comments. In general, it is a good idea to leave this at mixed, since editorial comments are meant to be suggestions for improvement and reasons for voting, which are no longer relevant and should be hidden when a story is posted, but are critical when a story is still in the queues.</P>" WHERE name="default_comment_view";
UPDATE vars SET description="<P>This variable determines the default format a poster uses when posting a comment or story.  The possible values are: text) plain text, all HTML tags rendered as literal text, and line breaks maintained; html) html tags rendered as html formatting instructions, line breaks must be marked with html formatting; and auto) autoformat, which extends plain text to allow simple formatting, links, and lists without requiring HTML.  The default value is html.<BR>\nThis variable can be overridden permanently (per user) by a user preference or temporarily by a user changing the comment post mode when posting a comment.  This variable should be set to reflect your site's planned audience.  The autoformat syntax is described in the special page \"Auto Format Mode Syntax\"; you may want to provide a link to that page to your users.</P>" WHERE name="default_post_type";
UPDATE vars SET description="<P>This variable determines the default appearance of signatures on comments.  The possible values are: regular) also known as retroactive, whatever is the current signature applies to all comments, past and present; and sticky) the signature on a comment is the one current when that comment was posted, and never changes.  The default value is regular.<BR>\nThis variable has no effect unless the variable <B>allow_sig_behaviour</B> is set to 1.  This variable can be overridden permanently (per user) by a user preference or temporarily by a user changing the signature behaviour when posting a comment." WHERE name="default_sig_behavior";
UPDATE vars SET description="<P>This variable determines the size of the textareas used for submitting comments and stories.  The possible values are any positive integer representing the number of columns (or letters) are in the textarea's width.  The default value is 50.<BR>\nThis variable can be overridden by a user preference.  The default value should not be set too high as visitors will have a variety of screen sizes and the form should not be so wide as to cause side-scrolling on a smaller screen.  The height of the textarea is set in the variable <B>default_textarea_rows</B>.</P>" WHERE name="default_textarea_cols";
UPDATE vars SET description="<P>This variable determines the size of the textareas used for submitting comments and stories.  The possible values are any positive integer representing the number of rows of text in the textarea's height.  The default value is 15.<BR>\nThis variable can be overridden by a user preference.  The default value should not be set too high as visitors will have a variety of screen sizes and the form should not be so high as to require scrolling of the entire page to see the top and the bottom of the textarea.  The width of the textarea is set in the variable <B>default_textarea_cols</B>.</P>" WHERE name="default_textarea_rows";
UPDATE vars SET description="<P>This variable determines which theme will be used as a base for all other themes to build on.  The possible values are any theme name which is a complete set of Scoop blocks when taken alone.  The default value is default.<BR>\nThis variable is used whether or not the variable <B>use_themes</B> is set to 1 or 0; it provides a full set of blocks to use alone or as a base for other themes either way.  It must always be set to a fully populated theme or your site may become completely unusable, depending on which blocks are missing.</P>" WHERE name="default_theme";
UPDATE vars SET description="<P>This variable determines which UID will have its preferences copied to a new account on creation. FIXME: not used in code or box anywhere. On the bug list." WHERE name="default_uid";
UPDATE vars SET description="<P>This variable affects the presentation of the site's email digest.  The possible values are any string valid to an email subject line.  The default value is \'My Site Digest\'.<BR>\nThis variable has no effect unless the variable <B>enable_story_digests</B> is set to 1.  It should also be changed to reflect your site name before enableing the email digest feature." WHERE name="digest_subject";
UPDATE vars SET description="<P>This variable determines whether or not the navigation bar at the bottom of stories is displayed.  The possible values are: 0) show the navigation bar; and 1) hide the navigation bar.  The default value is 0.<BR>\nThe navigation bar is displayed directly underneath the story text and provides links to the previous and next stories.  Which stories those are can be the subject of confusion among users of the site.</P>" WHERE name="disable_story_navbar";
UPDATE vars SET description="<P>This variable determines whether or not the mode of a comment posted to a story in one of the queues is automatically set to \"editorial\" or if it is not pre-set.  The possible values are: 0)do not pre-set the comment type; and 1) pre-set the comment type to editorial.  The default value is 0.<BR>\nOnce a story is out of the queue and is published, editorial comments are hidden by default.  If a comment type is not chosen by the comment poster or this variable, it is set to editorial on the first preview.  Users must have the permission <B>editorial_comments</B> in order to post comments in editorial mode.</P>" WHERE name="editorial_comment_default";
UPDATE vars SET description="<P>This variable determines whether or not users will have the option of requesting a story digest sent to their email address periodically.  The possible values are: 0) users cannot request a digest and digests will not be sent; and 1) users may request a digest and digests will be sent according to the schedule requested.<BR>\nBefore enabling this variable, make sure that the variables <B>digest_subject</B> and <B>local_email</B>, the blocks <B>digest_header</B> and <B>digest_footer</B> (or <B>digest_headerfooter</B> if you want the header and footer of the email to be the same) are properly set, and that the <B>digest</B> cron is enabled." WHERE name="enable_story_digests";
UPDATE vars SET description="<P>This variable determines whether or not your site will handle subsections.  The possible values are: 0) subsections are not used; and 1) subsections are used.  The default value is 0.<BR>\nPlease see the Scoop Admin Guide for more information on Scoop's subsections.</P>" WHERE name="enable_subsections";
UPDATE vars SET description="<P>This variable determines the number of votes a story in the voting queue must receive before the auto-post algorithm activates and determines if and where to post the story.  The possible values are any positive integer number, or any positive percentage.  The default value is -1.<BR>\nThis variable has no effect unless the variable <B>use_auto_post</B> is set to 1.  If the variable <B>auto_post_use_time</B> is set to 1, this variable is ignored and a time-based limit is used to activate the auto-post algorithm instead.</P>" WHERE name="end_voting_threshold";
UPDATE vars SET description="<P>This variable determines how long a form key (used in comment and story posting) is valid for.  The possible values are any positive number of seconds.  The default value is 21600 (6 hours).<BR>\nThe formkey is required to validate comments and stories, and helps prevent accidental duplicate posting due to double-clicking the Post button and similar situations.</P>" WHERE name="formkey_timeout";
UPDATE vars SET description="<P>This variable determines whether a posted story should be placed on the front page or in the section page only.  The possible values are any decimal number between 0 and 1.  The default value is 0.50.<BR>\nThe number of front page votes is divided by the total number of positive votes to provide the ratio of front page votes.  If the calculated ratio is less than the value of this variable, the article is posted to the section.  This variable only takes effect if a story is voted up through the normal voting queue, and not if the story is posted using the auto-post algorithm.</P>" WHERE name="front_page_ratio";
UPDATE vars SET description="<P>This variable determines whether or not diaries can be searched using Scoop's search form.  The possible values are: 0) allow diary searching; and 1) do not allow diary searching.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>use_diaries</B> is set to 1.</P>" WHERE name="hide_diary_search";
UPDATE vars SET description="<P>This variable determines whether or not comments to stories with comments disabled can be found in a comment search.  The possible values are: 0) allow disabled comments in search results; and 1) hide disabled comments in search results.  The default value is 0.<BR>\nStories with comments disabled don't display any comments or the comment controls when the story is viewed.</P>" WHERE name="hide_disabled_comments";
UPDATE vars SET description="<P>This variable determines the score at which a story in the voting queue is hidden from sight.  The possible values are any negative integer, or any positive percentage.  The default value is -2.<BR>\nIf the value is a percentage, it is interpreted as the negative of the percentage of total user accounts.  If the value is a number, it is interpreted as an absolute score.  As soon as a vote makes the story's score at or below the value in this variable, the story is removed from the voting queue and hidden.  Do not put a positive number (except a percentage) in this variable, as stories begin voting with a score of 0.  After a single positive vote, the score will then be 1, below or equal to all positive numbers, and resulting in every single story being hidden." WHERE name="hide_story_threshold";
UPDATE vars SET description="<P>This variable determines whether or not comments from stories not published to either the front of any section are displayed in search results.  The possible values are: 0) comments attached to stories in the queue or hidden are shown in search results; and 1) comments attached to stories in the queue or hidden are not shown in search results.  The default value is 0.<BR>\nThis variable only applies to search results; comments on hidden stories can still be viewed when this variable is set to 1.</P>" WHERE name="hide_unposted_comments";
UPDATE vars SET description="<P>This variable contains a list of hooks recognised by Scoop for use in the Hooks Admin Tool.  The format of this variable is: one hook definition per line; each definition consists of the hook name and a comma-separated list of arguments it accepts in parentheses.<BR>\nEach hook is named based on an activity that can be taken on a Scoop site.  In the Hooks Admin Tool, each of these hooks can have code attached which will run when those activities are performed.  See the Scoop Admin Guide for more details.</P>" WHERE name="hooks";
UPDATE vars SET description="<P>This variable is used as a prefix for all image files.  The possible values are either an absolute pathname on the local server (\"/images\") with no trailing slash, or a fully qualified URL on a different server (\"http://images.example.com\") with no trailing slash.<BR>\nIf the value does not start with either a / or an http://, the browser will attempt to download the images relative to what it perceives as the current directory, which will work for the front page but no others.</P>" WHERE name="imagedir";
UPDATE vars SET description="<P>This variable determines how long login sessions are saved for.  The possible values are in the format time unit (eg, 5 day) and can be any valid time.  The number may be any positive integer, and the unit may be any of second, minute, hour, day, month, or year.<BR>\nThis variable has no effect unless the <B>sessionreap</B> cron is enabled.  Login sessions are updated on every visit, so frequent visitors will not have their sessions expire.  Expired sessions result in logging out the user; they will have to log in again on their next visit.</P>" WHERE name="keep_sessions_for";
UPDATE vars SET description="<P>This variable is used as the from address whenever Scoop has to send an email.  The possible values are any valid email address.  The default is an invalid email address and must be changed.<BR>\nThis email address should probably be one you check regularly.  Since members are send email from this address, they are likely to think that they can send to it as well, if they have any questions.  If this email address is not valid, nobody will be able to create accounts.</P>" WHERE name="local_email";
UPDATE vars SET description="<P>This variable is used when a user logs off.  The possible values are an absolute path (beginning with a /), a fully qualified URL, or blank, which will go to the site's front page.  The default value is blank.<BR>\nIf you like, you can create a page saying goodbye or any other message appropriate for logging out using the Special Pages Admin Tool, and put its path here.</P>" WHERE name="logout_url";
UPDATE vars SET description="<P>This variable determines whether or not ad impressions and clickthroughs are logged.  The possible values are: 0) do not log individual impressions; and 1) log individual impressions.  The default value is 0.<BR>\nAd logging includes the UID and IP of the person viewing or clicking the ad, as well as the ad's ID and a timestamp.  This variable has no effect unless the advertising system is active; see the Scoop Admin Guide for more details on advertising.</P>" WHERE name="log_ip_for_ads";
UPDATE vars SET description="<P>This variable determines whether or not a notice will be sent to the advertiser when a particular ad has run out of impressions.  The possible values are: 0) do not email the advertiser when the last impression is viewed; and 1) email the advertiser when the last impression is viewed.  The default value is 1.<BR>\nThis variable has no effect unless the advertising system is active; see the Scoop Admin Guide for more details on advertising.</P>" WHERE name="mail_ad_finished_reminder";
UPDATE vars SET description="<P>This variable determines whether or not a notice will be sent to the advertiser when a particular ad has almost run out of impressions.  The possible values are: 0) do not email the notice; and 1) email the notice.  The default value is 1.<BR>\nThe number of impressions remaining which triggers the notice is set in the variable <B>mail_ad_reminder_on</B>.  This variable has no effect unless the advertising system is active; see the Scoop Admin Guide for more details on advertising.</P>" WHERE name="mail_ad_reminders";
UPDATE vars SET description="<P>This variable determines how many impressions must be left for Scoop to send the advertiser a notice informing him his impressions are running low.  The possible values are any positive integer.  The default value is 100.<BR>\nThis variable has no effect unless the variable <B>mail_ad_reminders</B> is set to 1, and the advertising system is active; see the Scoop Admin Guide for more details on advertising.  The value should be high enough that the advertiser has time to return to the site and create a new ad, but low enough that the campaign really is \"almost finished\", relative to the minimum number of impressions that may be purchased.</P>" WHERE name="mail_ad_reminder_on";
UPDATE vars SET description="<P>This variable determines the default number of story summaries to display on the front page, everything, and section index pages.  The possible values are any positive integer.  The default value is 8.<BR>\nThis variable can be overridden by a user preference.</P>" WHERE name="maxstories";
UPDATE vars SET description="<P>This variable determines the default number of story titles to display in the \"Older stories\" box on the front, everything, and section index pages.  The possible values are any positive integer.  The default value is 10.<BR>\nThis variable can be overridden by a user preference.  The \"Older stories\" box only displays stories older than the first page of the index; if you page back using the Next and Previous buttons, the list does not change to show stories older than the page you are currently on.</P>" WHERE name="maxtitles";
UPDATE vars SET description="<P>This variable determines how many accounts can be created per day from a given IP address.  The possible values are any positive integer.  The default value is 2.<BR>\nThis number should always be 1 or higher, or nobody will be allowed to create an account.  Users behind proxies (such as at work, or at school, and some ISPs) will all appear to come from the same IP address, so we can't limit the number of accounts total per IP.</P>" WHERE name="max_accounts_per_day";
UPDATE vars SET description="<P>This variable determines how many comments a user can post before triggering the rate throttling mechanism used to limit crapflooding.  The possible values are any positive integer.  The default value is 4.<BR>\nThe variable <B>rate_limit_minutes</B> is used in combination with this variable to calculate a posting rate; if the rate of <B>max_comments_submit</B>/<B>rate_limit_minutes</B> is exceeded, the user is blocked from posting for a short time, set by the variable <B>timeout_minutes</B>.  These three values should be set so that most normal users will never encounter them, very active users will only rarely encounter them, and people or scripts attempting to flood the site with comments will be locked out.  The default values should probably only be changed if they aren't working.</P>" WHERE name="max_comments_submit";
UPDATE vars SET description="<P>This variable determines how many stories one user can have in the edit queue at one time.  The possible values are any positive integer.  The default value is 1.<BR>\nThis variable has no effect unless the edit queue is turned on for the user submitting the stories, using the perm <B>edit_own_story</B>.</P>" WHERE name="max_edit_stories";
UPDATE vars SET description="<P>This variable determines the maximum number of characters Scoop will allow in the introtext part of a story.  The possible values are: 0) no limit; and any positive integer) the number of characters (including spaces but excluding HTML) permitted.  The default value is 0.<BR>\nThe variable <B>max_intro_words</B> does the same thing but counts words instead of characters.  Only one of the two should be used.</P>" WHERE name="max_intro_chars";
UPDATE vars SET description="<P>This variable determines the maximum number of words Scoop will allow in the introtext part of a story.  The possible values are: 0) no limit; and any positive integer) the number of words (excluding HTML).  The default value is 0.<BR>\nThe variable <B>max_intro_chars</B> does the same thing but counts characters instead of words.  Onely one of the two should be used.</P>" WHERE name="max_intro_words";
UPDATE vars SET description="<P>This variable determines how long the introtext in your site's RDF feed may be, in number of words, and replaces anything more with the string \"...\".  The possible values are: 0) no limit; and any positive integer) the number of words in the RDF feed.  The default value is 15.<BR>\nThis variable has no effect unless the RDF generator is active.  See the Scoop Admin Guide for details.</P>" WHERE name="max_rdf_intro";
UPDATE vars SET description="<P>This variable determines how many stories a user can post before triggering the rate throttlineg mechanism used to limit crapflooding.  The possible values are any positive integer.  The default value is 2.<BR>\nThe variable <B>rate_limit_minutes</B> is used in combination with this variable to calculate a posting rate; if the rate of <B>max_stories_submit</B>/<B>rate_limit_minutes</B> is exceeded, the user is blocked from posting for a short time, set by the variable <B>timeout_minutes</B>.  These three values should be set so that most normal users will never encounter them, very active users will only rarely encounter them, and people or scripts attempting to flood the site with comments will be locked out.  The default values should probably only be changed if they aren't working." WHERE name="max_stories_submit";
UPDATE vars SET description="<P>This variable determines the maximum amount of accumulated rate-throttle timout time a user can have before being blocked from posting permanently.  The possible values are any positive number of minutes.  The default value is 300.<BR>\nSee the Scoop Admin Guide for a description of rate throttling and the timeout.</P>" WHERE name="max_timeout";
UPDATE vars SET description="<P>This variable determines the minimum amount of money Scoop will allow people to pay when ordering ads or subscriptions.  FIXME: Yet another unimplemented ad feature.</P>" WHERE name="min_ad_prepay_amount";
UPDATE vars SET description="<P>This variable determines the number of minutes required between password requests.  The possible values are any positive number of minutes.  The default value is 120.<BR>\nWhen a password is requested, a new password is created and emailed to the account holder at their \"real email\" account.  This variable is designed to prevent a user from being flooded with new password emails sent by an abusive user.</P>" WHERE name="min_pw_request_interval";
UPDATE vars SET description="<P>This variable determines whether or not comments posted to diaries are counted toward a user's mojo.  The possible values are: 0) comments in diaries are treated the same as other comments; and 1) comments in diaries do not have their ratings counted in mojo calculations.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>use_mojo</B> is set to 1.</P>" WHERE name="mojo_ignore_diaries";
UPDATE vars SET description="<P>This variable determines the maximum number of comments that count towards a user's mojo score.  The possible values are any positive integer.  The default value is 30.<BR>\nThis value is the number of rated comments, not the number of total comments, counted toward mojo.  Unrated comments are excluded from the calculation entirely and have no effect on mojo at all.  Newer comments are weighted higher than older comments, using this value is a weight factor.  See the Scoop Admin Guide for details on mojo calculation.  See also <B>mojo_max_days</B>.  This variable has no effect unless the variable <B>use_mojo</B> is set to 1.</P>" WHERE name="mojo_max_comments";
UPDATE vars SET description="<P>This variable determines the maximum age of comments that count towards a user's mojo score.  The possible values are any positive number of days.  The default value is 60.<BR>\nThis value is used when selecting the comments to be used in mojo calculations; only comments newer than this will be considered.  Mojo must be maintained and cannot be accumulated.  See the Scoop Admin Guide for details on mojo calculation.  See also <B>mojo_max_comments</B>.  This variable has no effect unless the variable <B>use_mojo</B> is set to 1.</P>" WHERE name="mojo_max_days";
UPDATE vars SET description="<P>This variable determines how many rated comments a user must have before being considered for \"Trusted User\" status.  The possible values are any positive integer.  The default value is 10.<BR>\nThis value should be less than the value in <B>mojo_max_comments</B> because a user will never have more than that number of comments considered for mojo calculations.  This variable has no effect unless the variable <B>use_mojo</B> is set to 1.</P>" WHERE name="mojo_min_trusted";
UPDATE vars SET description="<P>This variable determines how many rated comments a user must have before being considered for \"Untrusted\" status.  The possible values are any positive integer.  The default value is 10.<BR>\nThis value should be less then the value in <B>mojo_max_comments</B> because a user will never have more than that number of comments considered for mojo calculations.  This variable has no effect unless the variable <B>use_mojo</B> is set to 1.</P>" WHERE name="mojo_min_untrusted";
UPDATE vars SET description="<P>This variable determines the minimum mojo score a user must have before being considered a \"Trusted User\".  The possible values are any number between <B>rating_min</B> and <B>rating_max</B>.  The default value is 3.5.<BR>\nTrusted users have some extra abilities; see the Scoop Admin Guide for details on trusted users.  This variable has no effect unless the variable <B>use_mojo</B> is set to 1.</P>" WHERE name="mojo_rating_trusted";
UPDATE vars SET description="<P>This variable determines whether or not the author of a story is notified when the story is either posted or dropped through the voting queue.  The possible values are: 0) do not send an email notification; and 1) send and email notification.  The default value is 1.<BR>\nEmail notification is only sent if Scoop does the posting or hiding through either the normal voting mechanism or the auto-post mechanism.  The email is sent from the email address specified in the variable <B>local_email</B>. Manually posted or hidden stories do not cause an email to be sent.  This can cause performance issues on very large sites, so if you're having problems try disabling this feature.</P>" WHERE name="notify_author";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will include the header information required to prevent proxies from caching your pages.  The possible values are: 0) do not include the cache prevention headers; and 1) include the cache prevention headers.  The default value is 0.<BR>\nSince Scoop's pages are generally entirely dynamic, having them cached will litter out-of-date scoop pages around in caches all over the internet.</P>" WHERE name="no_cache";
UPDATE vars SET description="<P>This variable determines which themes to apply in what order.  The possible values are a comma-separated list of criteria.  The default value is section.<BR>\nThis variable has no effect unless the variable <B>use_themes</B> is set to 1.  The themes associated with the criteria are applied in the order listed here, with later themes overwriting earlier ones, if they overlap.  The possible criteria are: section, siteid, agent, pref, and group.  See the Scoop Admin Guide for more information on themes.</P>" WHERE name="order";
UPDATE vars SET description="<P>This variable sets the filesystem location of cached pages.  The possible values are an absolute filesystem path which is owned by the apache user, or at least for which the apache user has write permission.  The default value is the probably invalid /www/scoop/cache.<BR>\nThis variable has no effect unless the variable <B>use_static_pages</B> is set to 1.  Pages are only cached for anonymous users.</P>" WHERE name="page_path";
UPDATE vars SET description="<P>This variable determines whether or not identifying info is logged in Apache's error log with every request.  The possible values are: 0) do not log extra information; and 1) record the extra information.  The default value is 0.<BR>\nThe information logged is the IP address, apache process ID, user ID, nickname, session, and any arguments, including the op and the full contents of any form.  There's a reason it's called \"paranoid\"...</P>" WHERE name="paranoid_logging";
UPDATE vars SET description="<P>This variable contains a list of all permissions used by Scoop, in a comma-separated list, one permission per line.<BR>\nIf any perm is added or removed from this list, the change will be reflected in the list of perms in the Groups Admin Tool.  Added perms default to off for all groups.  Removed perms are only removed from the admin tool; any removed perms that had been granted to groups before removal are still granted to those groups afterward.</P>" WHERE name="perms";
UPDATE vars SET description="<P>This variable determines how old a poll must be before it is archived.  The possible values are: 0) do not archive polls; and any positive integer) the age of a poll in days before it will be considered for archiving.  The default value is 0.<BR>\nThis variable has no effect unless the archiving system is active.</P>" WHERE name="poll_archive_age";
UPDATE vars SET category="Polls,Archive" WHERE name="poll_archive_age";
UPDATE vars SET description="<P>This variable contains the file name of the image used to create the poll bars.  The possible values are the name of a file in the images/ directory.  The default value is pollbar.gif<BR>\nThis image should be fairly simple as it is stretched out to create bars of the appropriate length.  Patterns will be distorted, unless they vary from top to bottom but not side to side.</P>" WHERE name="poll_img";
UPDATE vars SET description="<P>This variable determines the number of answer fields for all new polls.  The possible values are any positive integer.  The default value is 10.<BR>\nIf this number is reduced after some polls are created, the existing polls are not affected and all their answers will still be available for viewing and voting.  This number only affects the number of poll form fields shown and processed when creating new polls and editing existing polls.</P>" WHERE name="poll_num_ans";
UPDATE vars SET description="<P>This variable determines the score a story must reach in the voting queue to be posted.  The possible values are: a positive integer) the absolute score of the story; and a positive percentage) a score represented as a percentage of registered users.  The default value is 4.<BR>\nIf the variable <B>use_alternate_scoring</B> is set to 1, this is the number of positive votes required; if it is set to 0, this is the score of the story found by adding all positive, negative, and neutral votes together.  If this number is a percentage, a score is calculated on the fly based on the number of registered users in the database.  So if you have a value of 5% here and there are currently 1,000 registered users, the post threshold will be 50.</P>" WHERE name="post_story_threshold";
UPDATE vars SET description="<P>This variable determines how long a story may remain in the edit queue before being forced to voting.  The possible values are a number followed by a letter indicating the time unit.  The default value is 2h (2 hours).<BR>\nRecognised time units are s (seconds), m (minutes), h (hours) and d (days).  The author of a story in the edit queue may move the story to voting at any time; if this hasn't happened by the time this time limit has been reached, Scoop will force the story to voting.  This variable has no effect unless the edit queue is active.</P>" WHERE name="queue_edit_max_time";
UPDATE vars SET description="<P>This variable contains the time span to calculate the posting rate for post throttling.  The possible values are any positive number of minutes.  The default value is 10.<BR>\nThis is used with the variables <B>max_comments_submit</B> and <B>max_stories_submit</B> to calculate the maximum allowed posting rate.  It should be set so that normal users will rarely or never encounter the limit, but abusive users or scripts attempting to flood the site with garbage comments or stories are blocked.  If the posting rate is exceeded, the user is blocked from posting for a time set in <B>timeout_minutes</B>.</P>" WHERE name="rate_limit_minutes";
UPDATE vars SET description="<P>This variable determines the maximum rating a comment can receive.  The possible values are any integer.  The default value is 5.</P>" WHERE name="rating_max";
UPDATE vars SET description="<P>This variable determines the minimum rating a normal user can give a comment.  The possible values are any integer.  The default value is 1.<BR>\nIf the variable <B>use_mojo</B> is set to 1, Trusted users (see the Scoop Admin Guide) can rate comments one point below this value, and any comment with an average score below this value are hidden from everybody except trusted users.</P>" WHERE name="rating_min";
UPDATE vars SET description="<P>This variable names the group a user is moved to if an admin wipes their ratings.  The possible value is any existing user group which does not have the perm <B>comment_rate</B> set.  The default value is blank.<BR>\nIf the variable is blank, the user's group is not changed and only past ratings are undone.  If an existing user group which still has permission to rate comments is set here, it's rather pointless.</P>" WHERE name="rating_wipe_group";
UPDATE vars SET description="<P>This variable contains the text of the copyright notice to include in the site's RDF feed.  The possible values are any string.  The default value will need to be changed, at least for the name of your site.<BR>\nThis variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.  Do not include special characters such as the copyright symbol in this field, as it causes some RDF parsers to choke.</P>" WHERE name="rdf_copyright";
UPDATE vars SET description="<P>This variable contains the name of the creator of your site's RDF feed.  The possible values are any string.  The default value is blank.<BR>\nThis variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.  If this variable is blank, the text in the variable <B>sitename</B> is used instead.</P>" WHERE name="rdf_creator";
UPDATE vars SET description="<P>This variable determines how many days worth of stories to include in the RDF file your site generates.  The possible values are any positive integer.  The default value is 30.<BR>\nThis is used in combination with <B>rdf_max_stories</B> to limit the number of headlines your site syndicates.  This variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.</P>" WHERE name="rdf_days_to_show";
UPDATE vars SET description="<P>This variable determines how long your site will wait before giving up when fetching another site's RDF feed.  The possible values are any positive number of seconds.  The default value is 60.<BR>\nThis variable has no effect unless the site is fetching RDF feeds for display; see the Scoop Admin Guide for details.</P>" WHERE name="rdf_fetch_timeout";
UPDATE vars SET description="<P>This variable names the file Scoop saves its generated RDF feed to.  The possible values are an absolute filesystem path.  The default is the probably incorrect /www/scoop/html/backend.rdf<BR>\nThis variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.  The file named must be writeable by the Apache server and in a web-accessible location.</P>" WHERE name="rdf_file";
UPDATE vars SET description="<P>This variable determines which http proxy (if any) Scoop uses when fetching external RDF feeds.  The possible values are a fully qualified domain name and port of the proxy.  The default value is blank.<BR>\nThis variable has no effect unless the site is fetching RDF feeds for display; see the Scoop Admin Guide for details.  If blank, Scoop connects directly when fetching; if filled, Scoop uses the server named as its proxy server.  The name must be in the form http://host.name:port/</P>" WHERE name="rdf_http_proxy";
UPDATE vars SET description="<P>This variable gives the full external URL of an image file you want included with your site's RDF feed, or blank.  The possible value is the fully qualified URL of your image file.  The default value is wrong.<BR>\nThis variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.  If you are including an image in your RDF feed, it should generally be fairly small; large images can ruin another site's layout, and they may refuse to display your feed for that reason.</P>" WHERE name="rdf_image";
UPDATE vars SET description="<P>This variable determines the maximum number of headlines to display in an external RDF feed.  The possible values are any positive integer.  The default value is 15.<BR>\nThis variable has no effect unless the site is fetching RDF feeds for display; see the Scoop Admin Guide for details.  This variable can be overruled by a user preference.</P>" WHERE name="rdf_max_headlines";
UPDATE vars SET description="<P>This variable determines the maximum number of stories to include in the site's generated RDF feed.  The possible values are any positive integer.  The default value is 7.<BR>\nThis variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.  This variable is used with the variable <B>rdf_days_to_show</B> to determine how many stories to include in the RDF file.</P>" WHERE name="rdf_max_stories";
UPDATE vars SET description="<P>This variable sets the identity of the publisher of the RDF file.  The possible values are any short string.  The default value is blank.<BR>\nThis variable has no effect unless the site is generating RDF feeds for syndication; see the Scoop Admin Guide for details.  If this is blank, the value of the variable <B>sitename</B> is used in its place.</P>" WHERE name="rdf_publisher";
UPDATE vars SET description="<P>This variable determines whether or not form elements (such as the search box Scoop includes in its RDF feeds) included in an external RDF feed are displayed.  The possible values are: 0) do not display form elements; and 1) display form elements.  The default value is 1.<BR>\nThis variable has no effect unless the site is fetching RDF feeds for display; see the Scoop Admin Guide for details.</P>" WHERE name="rdf_use_forms";
UPDATE vars SET description="<P>This variable determines whether or not images included in an external RDF feed are displayed.  The possible values are: 0) do not display images; and 1) display images.  The default value is 1.<BR>\nThis variable has no effect unless the site is fetching RDF feeds for display; see the Scoop Admin Guide for details.</P>" WHERE name="rdf_use_images";
UPDATE vars SET description="<P>This variable determines how many topic images are shown in the (slashdot-style) list of most recent story topics.  The possible values are any positive integer.  The default value is 0.<BR>\nFIXME: The box displaying the recent topic images is not included in Scoop by default.  It seems to have been lost.</P>" WHERE name="recent_topics_num";
UPDATE vars SET description="<P>This variable determines whether or not a user must preview story and diary submissions at least once before submitting.  The possible values are: 0) user can submit without previewing; and 1) user must preview at least once before submitting.  The default values is 1.</P>" WHERE name="require_story_preview";
UPDATE vars SET description="<P>This variable determines whether or not advertisers must provide extra information before they can submit advertisements to the site.  FIXME: Yet another unimplemented ad feature." WHERE name="req_extra_advertiser_info";
UPDATE vars SET description="<P>This variable is the path that must precede all Scoop-generated pseudo-directories.  The possible values are any absolute path prefix, with no trailing slash.  The default is blank.<BR>\nThis will only be used if you are installing Scoop into a subdirectory.  If you are installing Scoop on its own virtualhost, this should be blank.  See the Scoop Admin Guide for details on how this variable should be set.</P>" WHERE name="rootdir";
UPDATE vars SET description="<P>This variable determines which sections will not be shown in the \"Everything\" pseudo-section or the RDF feed.  The possible values are a comma-separated list of section names.  The default is blank.<BR>\nFIXME: diary and ad sections should be in here, not special cased in the code.  It's on the bug list.</P>" WHERE name="sections_excluded_from_all";
UPDATE vars SET description="<P>This variable sets which theme is applied to the news section.  The possible value is any existing theme name.  The default value is greyscale.<BR>\nThis variable has no effect unless the variable <B>use_themes</B> is turned on.  This is a demonstration variable; to set themes for other sections, create new variables with the internal name of the section in place of \"news\", the same way this variable is set up.  For more information on setting up themes, see the Scoop Admin Guide.</P>" WHERE name="section_news";
UPDATE vars SET description="<P>This variable contains the secure version of <B>site_url</B>.  The possible values are a fully qualified domain name.  The default value is wrong.<BR>\nThis should most likely be the same as <B>site_url</B> except with https:// instead of http://.  This variable has no effect unless you have the payment processing system turned on.  See the Scoop Admin Guide for more details.  If you have a secure site running, the entire Scoop site is browsable using it.  Some pages (such as those collecting payment details) must be; you may be able to configure Apache to disallow secure browsing of other pages.</P>" WHERE name="secure_site_url";
UPDATE vars SET description="<P>This variable contains the full path to the sendmail program Scoop uses to send email.  The possible value is an absolute local filesystem path to the sendmail executable.  The default value is /usr/sbin/sendmail<BR>\nThis variable has no effect unless the SMTP host variable in httpd.conf is set to \"-\".</P>" WHERE name="sendmail_program";
UPDATE vars SET description="<P>This variable determines whether or not a story can be assigned a \"department\" (i.e., from the i-love-scoop department) to be displayed under the title.  The possible values are: 0) do not use departments; and 1) use departments.  The default value is 0.<BR>\nThis toggles both the display of the department when viewing the story, and the presence of an input box when submitting a story.</P>" WHERE name="show_dept";
UPDATE vars SET description="<P>This variable determines when new/read comments are tracked.  The possible values are: all) track and display new comments for all stories for all registered users; hotlist) track and display new comments only for stories a user has in his hotlist; and never) do not track or display new comments for any story or any user.  The default value is all.<BR>\nNew comments are marked with the contents of the block <B>new_comment_marker</B> when appropriate.</P>" WHERE name="show_new_comments";
UPDATE vars SET description="<P>This variable determines whether or not a new user is sent to the user preferences page the first time he logs on.  The possible values are: 0) the first login is normal, and sends the user to the front page; and 1) the first login is special, and sends the user to his preferences page.  The default value is 1.</P>" WHERE name="show_prefs_on_first_login";
UPDATE vars SET description="<P>This variable determines whether or not the post and hide thresholds are displayed in the story moderation queue.  The possible values are: 0) do not show the thresholds; and 1) show the post and hide thresholds.  The default is 0.<BR>\nThe thresholds are taken from the variables <B>post_story_threshold</B> and <B>hide_story_threshold</B>.  If one or both of those thresholds are percentages, the numeric value at the time of the page request is calculated and displayed instead of the percentage.</P>" WHERE name="show_threshold";
UPDATE vars SET description="<P>This variable contains the name of the site.  The possible value is any short string.  The default is Scoop.<BR>\nThis value is used in the emails sent by the site, the browser title bar, and the RDF feeds.</P>" WHERE name="sitename";
UPDATE vars SET description="<P>This variable contains the URL for the server the site is hosted on.  The possible value is a fully qualified domain name with no path information and no trailing slash.  The default value is wrong.<BR>\nThe <B>rootdir</B> is appended to this variable to create the full URL to the site's front page.  If this variable or <B>rootdir</B> ends in a slash, many URLs including the ones sent in emails will not work properly.</P>" WHERE name="site_url";
UPDATE vars SET description="<P>This variable determines what percentage of spam votes must be cast for an article in the editing queue to be forced to voting without the author's consent.  The possible values are any number between 0 and 1.  The default value is 0.25.<BR>\nThis variable has no effect unless the variable <B>use_anti_spam</B> is set to 1.  For a description of the edit queue anti-spam algorithm, see the Scoop Admin Guide.</P>" WHERE name="spam_votes_percentage";
UPDATE vars SET description="<P>This variable determines how many spam votes must be registered before the anti-spam algorithm determines whether or not force a story into the voting queue without the author's consent.  The possible values are any positive integer.  The default value is 100.<BR>\nThis variable has no effect unless the variable <B>use_anti_spam</B> is set to 1.  For a description of the edit queue anti-spam algorithm, see the Scoop Admin Guide.</P>" WHERE name="spam_votes_threshold";
UPDATE vars SET description="<P>This variable determines whether or not a user's comments and stories are spellchecked by default.  The possible values are: 0) not spellchecked; the user must specifically check the spellcheck box to have posts spellchecked; and 1) automatically check the spellcheck box so all posts are spellchecked.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>spellcheck_enabled</B> is set to 1.  This variable can be overridden by a user preference.</P>" WHERE name="spellcheck_default";
UPDATE vars SET description="<P>This variable determines whether or not Scoop uses the optional spell-checking functionality.  The possible values are: 0) do not use spellcheck; and 1) use spellcheck.  The default value is 0.<BR>\nSpell-checking requires the aspell program and the Text::Aspell perl module.  See the Scoop Admin Guide for details.</P>" WHERE name="spellcheck_enabled";
UPDATE vars SET description="<P>This variable determines which English spelling variant should be used by default.  The possible values are: american; british; and canadian.  The default value is american.<BR>\nThis variable has no effect unless the variable <B>spellcheck_enabled</B> is set to 1.  This variable can be overridden by a user preference.</P>" WHERE name="spellcheck_spelling";
UPDATE vars SET description="<P>This variable determines how many items will be displayed in lists.  The possible values are any positive integer.  The default value is 30.<BR>\nThis value applies to the story list, poll list, and ad list admin tools, as well as the voting and edit queue.</P>" WHERE name="storylist";
UPDATE vars SET description="<P>This variable determines the age in days of stories to be archived.  The possible values are any positive number of days.  The default value is 0 (disabled).<BR>\nThis variable has no effect unless the archive database has been created and configured properly.  See the Scoop Admin Guide for details.  The effect of this variable is modified by the variable <B>comment_archive_age</B>; stories older than the value in this variable but with comments newer than the age specified in <B>comment_archive_age</B> will not be archived.</P>" WHERE name="story_archive_age";
UPDATE vars SET category="Stories,Archive" WHERE name="story_archive_age";
UPDATE vars SET description="<P>This variable determines whether or not a story in the voting queue receives an automatic zero (Abstain) vote when the story is viewed.  The possible values are: 0) do not auto-vote; and 1) auto-vote.  The default value is 0.<BR>\nThis variable is only useful if your site is using a closed voting queue and stories are published by an editor marking it as published instead of the normal voting mechanism.  The purpose of this variable is to allow editors to see which stories they've read already.  If this variable is set, editing a story clears all votes, indicating to the editor that there has been an unread change to the story.<BR>\nThis variable should never be set to 1 if you are using an open voting queue.</P>" WHERE name="story_auto_vote_zero";
UPDATE vars SET description="<P>This variable determines whether Scoop counts words or bytes when displaying the size of a story.  The possible values are: 0) count bytes (letters) in the story; and 1) count words in the story.  The default value is 1.<BR>\nWords are defined as anything separated by spaces or tabs.  The number of bytes is displayed as the number of bytes, kilobytes, or megabytes, whichever is most appropriate.</P>" WHERE name="story_count_words";
UPDATE vars SET description="<P>This variable determines how many passes Scoop will make looking for keys before calling it a day and clearing any remaining.  The possible values are any positive integer.  The default value is 5.<BR>\nFIXME: There's a bug in this somewhere; all keys that need to be interpolated are, no matter what you set this value to.  Just leave it be for now.</P>" WHERE name="template_recurse";
UPDATE vars SET description="<P>This variable determines how long a user exceeding the post throttle rate will be blocked from posting.  The possible values are any positive number of minutes.  The default value is 2.<BR>\nThe post throttle rate is set using the variables <B>max_post_comments</B>, <B>max_post_stories</B>, and <B>rate_limit_minutes</B>.  If a blocked user attempts to post while locked out, the timeout period doubles and restarts.  If the timeout period exceeds the value given in the variable <B>max_timeout</B>, the user is moved to the group specified in the variable <B>untrusted_group</B>, or failing that, the Anonymous group.</P>" WHERE name="timeout_minutes";
UPDATE vars SET description="<P>This variable determines whether Scoop displays times using the 24 hour format, or with AM/PM.  The possible values are: 0) use AM/PM times; and 1) use the 24-hour clock.  The default value is 0.</P>" WHERE name="time_24h_format";
UPDATE vars SET description="<P>This variable tells Scoop which time zone the server's clock is set to.  The possible values are any valid time zone string.  The default value is EST.<BR>\nIf this variable is set incorrectly, all display times will be wrong, leading to much confusion.  This variable is also used as the default for the user preference.</P>" WHERE name="time_zone";
UPDATE vars SET description="<P>This variable determines where Scoop will look for topic images.  The possible values are a valid directory name under the Scoop image directory, beginning with /.  The default value is /topics.<BR>\nThe contents of this variable are appended to the variable <B>imagedir</B> to provide the path to the topic images.  The topic image directory must be under the regular image directory.</P>" WHERE name="topics";
UPDATE vars SET description="<P>This variable determines whether or not topic images are shown to anonymous users.  The possible values are: 0) do not show topic images; and 1) show topic images.  The default value is 1.<BR>\nThis variable has no effect unless the variable <B>use_topics</B> is set to 1.</P>" WHERE name="topic_images_default";
UPDATE vars SET description="<P>This variable determines whether or not a user can delete the files he uploaded to Scoop.  The possible values are: 0) do not allow file deletion; and 1) allow file deletion.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.  If users are permitted to embed items (such as images) in their file upload space in their stories, allowing file deletion will break the display.</P>" WHERE name="upload_delete";
UPDATE vars SET description="<P>This variable determines where admin uploaded files will be accessible through the web.  The possible values are an absolute path, ending in a /.  The default value is blank.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.  The admin upload path is shared by all users with the perm <B>upload_admin</B>.</P>" WHERE name="upload_link_admin";
UPDATE vars SET description="<P>This variable determines where user uploaded files will be accessible through the web.  The possible values are an absolute path, ending in a /.  The default value is blank.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.  The user upload path is a subdirectory named for the user's UID under the path defined here.</P>" WHERE name="upload_link_user";
UPDATE vars SET description="<P>This variable determines the maximum file size permitted in user and admin uploads.  The possible values are any positive number of kilobytes or zero to disable the maximum size check.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.</P>" WHERE name="upload_max_file_size";
UPDATE vars SET description="<P>This variable determines where admin uploaded files are saved on the filesystem.  The possible values are any absolute local filesystem path, ending with a /.  The default value is blank.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.  The directory named in this variable must be either owned by the web server user, or writeable by it." WHERE name="upload_path_admin";
UPDATE vars SET description="<P>This variable determines where user uploaded files are saved on the filesystem.  The possible values are any absolute local filesystem path, ending with a /.  The default value is blank.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.  The directory named in this variable must be either owned by the web server user, or writeable by it, and the web server must be able to create subdirectories in this directory." WHERE name="upload_path_user";
UPDATE vars SET description="<P>This variable determines whether or not uploaded files can be renamed by their owner.  The possible values are: 0) do not allow file deletion; and 1) allow file deletion.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.  If users are permitted to embed items (such as images) in their file upload space in their stories, allowing file renaming will break the display of those images.</P>" WHERE name="upload_rename";
UPDATE vars SET description="<P>This variable determines the maximum amount of space one user can take up with his uploaded files.  The possible values are any positive number of kilobytes, or zero to disable the limits.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>allow_uploads</B> is set to 1.</P>" WHERE name="upload_user_quota";
UPDATE vars SET description="<P>This variable determines the initial rating all registered users will receive on their comments.  The possible values are any number between <B>rating_min</B> and <B>rating_max</B>.  The default value is 3.<BR>\nThis variable has no effect unless the variable <B>use_initial_rating</B> is set to 1.</P>" WHERE name="user_default_points";
UPDATE vars SET description="<P>This variable determines which themes a user may choose from in his display preferences.  The possible values are a comma-separated list of themes present in the Blocks Admin Tool.  The default value is blank.<BR>\nThis variable has no effect unless the variables <B>use_themes</B> and <B>allow_user_themes</B> are set to 1.  The user may choose between the themes listed here.</P>" WHERE name="user_themes";
UPDATE vars SET description="<P>This variable determines which of the themes available to the user is the default.  The possible values are any theme named in <B>user_themes</B> or blank.  The default value is blank.<BR>\nThis variable has no effect unless the variables <B>use_themes</B> and <B>allow_user_themes</B> are set to 1.  If this variable is blank, the default theme is \"none\" and having no theme applied is an option.</P>" WHERE name="user_theme_default";
UPDATE vars SET description="<P>This variable determines whether or not Scoop's advertisement system is active.  The possible values are: 0) no ads; and 1) use ads.  The default value is 0.<BR>\nBefore turning on the ad system, please read the Scoop Admin Guide for detailed instructions on its configuration and use.</P>" WHERE name="use_ads";
UPDATE vars SET description="<P>This variable determines which scoring calculations are used in the story voting queue.  The possible values are: 0) compare the story's total score to the thresholds; and 1) compare the number of positive and negative votes to the thresholds separately.  The default value is 0.</P>" WHERE name="use_alternate_scoring";
UPDATE vars SET description="<P>This variable determines whether or not a spam button is displayed in the editing queue.  The possible values are: 0) no spam button; and 1) show the spam button.  The default value is 1.<BR>\nThe variables <B>spam_votes_threshold</B> and <B>spam_votes_percentage</B> are used to calculated whether or not a story should be forcibly removed from the edit queue.  Without the spam button, a \"crapflood\" or garbage story placed in the edit queue will remain there until the edit queue time limit.</P>" WHERE name="use_anti_spam";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will make a posting decision after certain criteria have been met, if the story is not posted or hidden using the normal voting mechanism.  The possible values are: 0) use only the normal voting mechanism; and 1) use the normal voting mechanism plus the auto-post algorithm where needed.  The default value is 0.<BR>\nThe criteria are based on the time the story has spent in the voting queue if the variable <B>auto_post_use_time</B> is set to 1, and based on the total number of votes received if that variable is set to 0.  See the Scoop Admin Guide for more details on the autopost algorithm.</P>" WHERE name="use_auto_post";
UPDATE vars SET description="<P>This variable determines whether or not user diaries are permitted.  The possible values are: 0) do not allow users to post or read diaries; and 1) allow users to post and read diaries.  The default value is 1.</P>" WHERE name="use_diaries";
UPDATE vars SET description="<P>This variable determines whether or not \"edit categories\" should be used.  The possible values are: 0) do not use edit categories; and 1) use edit categories.  The default value is 0.<BR>\nEdit categories are really only useful with a closed moderation queue, and provide a way for the admins to distinguish between stories still being written and stories being considered for publication.  See the Scoop Admin Guide for details.</P>" WHERE name="use_edit_categories";
UPDATE vars SET description="<P>This variable determines whether or not Scoop should use the \"fulltext\" indexes when searching comments and stories.  The possible values are: 0) do not use fulltext indexes; and 1) use fulltext indexes.  The default value is 0.<BR>\nThis variable should only be set to 1 if your database is capable of fulltext indexes and you have created the required indexes beforehand.  Fulltext indexes allows you to sort search results by relevance or date, and weights search terms based on how frequently they appear.  See the Scoop Admin Guide for details.</P>" WHERE name="use_fulltext_indexes";
UPDATE vars SET description="<P>This variable determines whether or not newly posted comments are given an initial rating.  The possible values are: 0) do not give an initial rating; and 1) give an initial rating.  The default value is 0.<BR>\nThe initial rating is completely overridden by the first real rating given by another user, unless the variable <B>real_initial_rating</B> is set to 1.  The actual value of the initial rating given is set in the variables <B>anonymous_default_points</B> and <B>user_default_points</B>.</P>" WHERE name="use_initial_rating";
UPDATE vars SET description="<P>This variable determines how much administrator activity is logged.  The possible values are: 0) log nothing; 1) log basic information; and 2) log extended information.  The default value is 0.<BR>\nLogging requires that the logging hooks as well as this variable are activated.  See the Scoop Admin Guide for more details.</P>" WHERE name="use_logging";
UPDATE vars SET description="<P>This variable determines whether or not the mojo system should be used to determine user trust levels.  The possible values are: 0) do not use mojo; and 1) use mojo.  The default value is 1.<BR>\nFor a description of mojo calculations and limits, and trusted and untrusted users, see the Scoop Admin Guide.</P>" WHERE name="use_mojo";
UPDATE vars SET description="<P>This variable determines whether or not external RDF feeds should be fetched, stored, and displayed.  The possible values are: 0) do not use external RDF feeds; and 1) use external RDF feeds.  The default value is 1.<BR>\nFor Scoop to fetch RDF feeds, the cron <B>rdf_fetch</B> must also be turned on.  See the Scoop Admin Guide for details.</P>" WHERE name="use_rdf_feeds";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will check your referer before allowing access to any administrator functions.  The possible values are: 0) do not check referer; and 1) check referer and deny administrator access if it does not match the server's hostname.  The default value is 0.<BR>\nThis is not real security; the referer field is very easy to change.  If your browser blocks the referer by default, you will not be able to perform any site administration.</P>" WHERE name="use_ref_check";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will cache story pages as plain text files for faster display to anonymous users.  The possible values are: 0) do not use static pages; and 1) use static pages.  The default value is 1.<BR>\nStatic pages are only shown to anonymous users, who do not get any customization beyond the comment view chosen.  The static pages are stored in the filesystem at the location defined in the variable <B>page_path</B>.  See the Scoop Admin Guide for details.</P>" WHERE name="use_static_pages";
UPDATE vars SET description="<P>This variable determines whether or not the subscription system is used.  The possible values are: 0) do not use subscriptions; and 1) use subscriptions.  The default value is 0.<BR>\nSee the Scoop Admin Guide for details on setting up the subscription system.</P>" WHERE name="use_subscriptions";
UPDATE vars SET description="<P>This variable determines whether or not themes are used at all.  The possible values are: 0) do not use any themes; and 1) use themes.  The default value is 0.<BR>\nSee the Scoop Admin Guide for details on configuring themes.</P>" WHERE name="use_themes";
UPDATE vars SET description="<P>This variable determines whether or not topics are used.  FIXME: this setting has weird behaviour that I've made suggestions for fixing and making more consistent.</P>" WHERE name="use_topics";
UPDATE vars SET description="<P>This variable determines whether or not comment poster IP addresses are displayed in the comment header.  The possible values are: 0) do not display IP addresses; and 1) display IP addresses.  The default value is 0.<BR>\nThis variable has no effect unless the variable <B>comment_ip_log</B> is set to 1 and the user has the perm <B>view_comment_ip</B>.</P>" WHERE name="view_ip_log";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will force a newline for a very long word in a comment which won't wrap on its own.  The possible values are: 0) do not force line wrapping; and 1) force line wrapping.  The default value is 1.<BR>\nThis feature has no effect on normal English writing, and only modifies a long series of non-space characters, such as those used to force a page ridiculously wide so readers have to scroll sideways.  The maximum length of a word without a space is set in the variable <B>wrap_long_lines_at</B>.</P>" WHERE name="wrap_long_lines";
UPDATE vars SET description="<P>This variable determines how long a word (non-space characters in a row) can be before Scoop forces a newline to allow browsers to wrap the lines properly.  The possible values are any positive integer.  The default value is 100.<BR>\nThis variable has no effect unless the variable <B>wrap_long_lines</B> is set to 1.  This variable should be set longer than any legitimate word, and short enough that displaying it will not widen the page for people with small browser windows.</P>" WHERE name="wrap_long_lines_at";
UPDATE vars SET description="<P>This variable determines whether or not Scoop will force a newline on long lines in the &lt;PRE&gt; environment.  The possible values are: 0) allow PRE lines to be as long as the user specifies; and 1) force a wrap after a certain length for PRE lines.  The default value is 1.<BR>\nThis variable is only useful if you have allowed the PRE tag in the variable <B>allowed_html</B>.</P>" WHERE name="wrap_pre";
UPDATE vars SET description="<P>This variable determines the maximum length of a line inside the PRE tag.  The possible values are any positive integer.  The default value is 100.<BR>\nThis variable has no effect unless the variable <B>wrap_pre</B> is set to 1.  This variable should be set long enough that it doesn't interfere with desirable displays (such as code snippets, if your site has programmer members) but short enough that lines near the maximum length do not widen the page excessively.</P>" WHERE name="wrap_pre_at";

UPDATE blocks SET block="<P>If this article is abusing the edit queue please indicate this by pressing the button below.</P>\n<FORM NAME=\"storymoderate\" ACTION=\"%%rootdir%%/\" METHOD=\"POST\">\n<P align=\"center\">\n\t<INPUT type=\"hidden\" NAME=\"op\" VALUE=\"displaystory\">\n\t<INPUT type=\"hidden\" NAME=\"sid\" VALUE=\"%%sid%%\">\n\t<INPUT type=\"hidden\" NAME=\"mode\" VALUE=\"spam\">\n\t%%formkey%%\n\t<INPUT type=\"hidden\" NAME=\"vote\" VALUE=\"-1\">\n\t<INPUT type=\"submit\" name=\"save\" value=\"Spam\">\n</P>\n</FORM>" WHERE bid="edit_instructions_abuse";

-- this block is horribly out of date, and points people to the really, really old docs.  Updated here for doc and CVS location.
UPDATE blocks SET block="<TABLE WIDTH=\"100%\" BORDER=1 CELLPADDING=2 CELLSPACING=0>\n\t<TR>\n\t\t<TD BGCOLOR=\"#006699\">\n\t\t\t%%box_title_font%%Where to learn about Scoop%%box_title_font_end%%\n\t\t</TD>\n\t</TR>\n\t<TR>\n\t\t<TD>\n\t\t\t%%norm_font%%\n<P>Holy Crap! You have your own <A HREF=\"http://scoop.kuro5hin.org\">Scoop</A> site now. Well, there's too many features for me to explain right here, but I can give you some places to look for help and whatnot.</P>\n<P>The main development site is at <A HREF=\"http://scoop.kuro5hin.org\">scoop.kuro5hin.org</A>. This contains links to all the other stuff, so poke around a little.</P>\n<P>For immediate help and assistance from the Scoop code monkeys, join the <A HREF=\"http://sourceforge.net/mail/?group_id=4901\">scoop-help mailing list</A>. This is practically a requirement for a pleasant Scoop administrative experience, as Scoop is rather complicated and it isn't always obvious where to find things.</P>\n<P>To help figure things out, there is a <A HREF=\"http://scoop.kuro5hin.org/guide/\">Scoop Admin Guide</A> which can hopefully answer most of your questions.</P>\n<P>Other things of note:</P>\n<UL>\n<LI> Many Scoop developers can often be found on IRC, channel #scoop at irc.slashnet.org.  If nobody is in that channel, try #kuro5hin\n<LI> The <A HREF=\"http://sourceforge.net/project/?group_id=4901\">main Sourceforge page</A> has some information on the project\n<LI> The latest code is always <A HREF=\"http://scoop.versionhost.com/viewcvs.cgi/\">in CVS</A> (username and password are both \"anonymous\")\n<LI> You can look at a convenient <A HREF=\"http://scoop.kuro5hin.org/special/sites\">list of other Scoop sites</A> to see what folks are doing with it\n</UL>\n\t\t\t%%norm_font_end%%\n\t\t</TD>\n\t</TR>\n</TABLE>\n" WHERE bid="scoop_intro";
